// EngineEntity.cpp : Defines the entry point for the console application.

//#include "stdafx.h"
#include <stdio.h>
#include "EngineEntity.h"

int main( int argc, char *argv[ ])
{
    EngineEntity* myEngineEntity = new EngineEntity();

    printf(myEngineEntity->getStateCapabilities());

    printf("ENGINE STATE: Initial state\n");
    printf("ENGINE STATE TRANSITION ->: Moving to the forwarding state\n\n");

    myEngineEntity->changeState(ForwardingState::Instance());
    printf(myEngineEntity->getStateCapabilities());

    printf("ENGINE STATE TRANSITION ->: Moving to the exit state\n\n");
    myEngineEntity->changeState(ExitState::Instance());
    printf(myEngineEntity->getStateCapabilities());

    printf("Deleting the engine instance.\n");    
    delete myEngineEntity;

	return 0;
}

EngineEntity::EngineEntity(void)
{
    _state = NULL;
	changeState(InitialState::Instance());
}

char* EngineEntity::getStateCapabilities(void)
{
    return _state->whatCanWeDo();
}

EngineEntity::~EngineEntity(void)
{
}

void EngineEntity::changeState(State* pState)
{
	if (pState != _state)
	{
		_state = pState;
	}
}